# Запрос / Query
    
Предназначен для выполнения запросов к базе данных.
  
## Свойства
    
### Параметры / Parameters
Доступ: Чтение

### Текст / Text
Доступ: Чтение/Запись

Тип значения: Строка
    
Содержит исходный текст выполняемого запроса.

### Таймаут / Timeout
Доступ: Чтение/Запись

Тип значения: Число
    
Время в секундах, в течение которого должно происходить ожидание выполнения команды. По умолчанию используется значение 30 секунд.


## Методы
    
### Выполнить / Execute()
    
Выполняет запрос к базе данных.
  
#### Возвращаемое значение

[РезультатЗапроса](РезультатЗапроса.md)
  
### ВыполнитьКоманду / ExecuteCommand()
    
Выполняет запрос на модификацию к базе данных.
  
#### Возвращаемое значение

Число - Число обработанных строк.
  
### УстановитьПараметр / SetParameter()
    
Устанавливает параметр запроса. Параметры доступны для обращения в тексте запроса.
С помощью этого метода можно передавать переменные в запрос, например, для использования в условиях запроса.
ВАЖНО: В запросе имя параметра указывается с использованием '@'.
  
#### Пример:
    Запрос.Текст = "select * from mytable where category_id = @category_id";
    Запрос.УстановитьПараметр("category_id", 1);
    

#### Параметры

* *ParametrName*: Строка - Имя параметра

* *ParametrValue*: Произвольный - Значение параметра

### УстановитьСоединение / SetConnection()
    
Установка соединения с БД.
  
#### Параметры

* *connector*: [Соединение](Соединение.md) - объект соединение с БД

### ИДПоследнейДобавленнойЗаписи

Возвращает уникальный ид последней добавленной записи, работает для SQLite, MySQL

#### Возвращаемое значение

Число - уникальный ид последней добавленной записи.