# Соединение / Connection
    
Соединение с БД. Используется для указания источника данных объекта Запрос.
  
## Свойства
    
### ТипыСУБД / DBTypes
Доступ: Чтение

Тип значения: [ТипСУБД](#ТипСУБД.md)
    
Типы поддерживаемых СУБД
  
### ТипСУБД / DBType
Доступ: Чтение/Запись

Тип значения: ТипСУБД
    
Тип подключенной СУБД
  
### Порт / Port
Доступ: Чтение/Запись

Тип значения: Число
    
Порт подключения
  
### Сервер / Server
Доступ: Чтение/Запись

Тип значения: Строка
    
Имя или IP сервера
  
### ИмяБазы / DbName
Доступ: Чтение/Запись

Тип значения: Строка
    
Имя базы, в случае с SQLITE - путь к базе
  
### ИмяПользователя / Login
Доступ: Чтение/Запись

Тип значения: Строка
    
Пользователь под которым происходит подключение.
Если СУБД MS SQL и пользователь не указан - используется Windows авторизация.
  
### Пароль / Password
Доступ: Чтение/Запись

Тип значения: Строка
    
Пароль пользователя
  
### Открыто / IsOpen
Доступ: Чтение

Тип значения: Булево
    
Статус соединения с БД: Открыто - Истина, Закрыто - Ложь.

### Состояние / State
Доступ: Чтение

Тип значения: ConnectionState
    
Состояние соединения:
        
- Closed - Закрыто.
- Open - Открыто.
- Connecting - Соединяется с источником.
- Executing - Выполняет команду
- Fetching - Получает данные
- Broken - Соединение оборвано.

### ПоследнееСообщениеОбОшибке / LastErrorMessage
Доступ: Чтение

Тип значения: Строка

Текст последней ошибки.
  
### СтрокаСоединения / ConnectionString
Доступ: Чтение/Запись

Тип значения: Строка
    
Подготовленная строка соединения. В случае sqlite аналог ИмяБазы
  
## Методы
    
### Открыть / Open()
    
Открыть соединение с БД
  
#### Возвращаемое значение

Булево
  
### Закрыть / Close()
    
Закрыть соединение с БД

### СоздатьЗапрос / CreateQuery()
    
Создать запрос с установленным соединением

#### Возвращаемое значение

Запрос
