#Использовать asserts
#Использовать sql

Перем юТест;

Функция ПолучитьТекстИзФайла(ИмяФайла)
    ФайлОбмена = Новый Файл(ИмяФайла);
    Данные = "";
    Если ФайлОбмена.Существует() Тогда
        Текст = Новый ЧтениеТекста(ИмяФайла, КодировкаТекста.UTF8);
        Данные = Текст.Прочитать();
        Текст.Закрыть();
    Иначе
        Возврат Ложь;
    КонецЕсли;
    возврат Данные;
КонецФункции

Процедура Инициализация()
КонецПроцедуры

Функция ПолучитьСписокТестов(Тестирование) Экспорт

	Суфикс = "НетПараметровДоступа";

	юТест = Тестирование;

	СписокТестов = Новый Массив;
	СписокТестов.Добавить("Тест_Должен_ПрочитатьДанные_sqlite"+Суфикс);
	СписокТестов.Добавить("Тест_Должен_ПрочитатьДанные_mssqlserver"+Суфикс);
	СписокТестов.Добавить("Тест_Должен_ПрочитатьДанные_mysql"+Суфикс);
	СписокТестов.Добавить("Тест_Должен_ПрочитатьДанные_postgresql"+Суфикс);

	Возврат СписокТестов;

КонецФункции

Процедура Тест_Должен_ПрочитатьДанные_sqlite() Экспорт

	Соединение = Новый Соединение();
	Соединение.ТипСУБД = Соединение.ТипыСУБД.sqlite;
	Соединение.ИмяБазы = ":memory:";
	Соединение.Открыть();

	ЗапросВставка = Новый Запрос();
	ЗапросВставка.УстановитьСоединение(Соединение);
	ЗапросВставка.Текст = "Create table testtypes (col1 integer, col2 text, col3 REAL, col4 NUMERIC, col5 blob)";
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "insert into testtypes (col1, col2, col3 , col4 , col5 ) values (@col1, @col2, @col3, @col4, @col5)";
	ЗапросВставка.УстановитьПараметр("col1", 1);
	ЗапросВставка.УстановитьПараметр("col2", "Сергей");
	ЗапросВставка.УстановитьПараметр("col3", 1.1234567890);
	ЗапросВставка.УстановитьПараметр("col4", 1.1234567890);
	ЗапросВставка.УстановитьПараметр("col5", "Большой текст");
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "select * from testtypes";
    ЗапросВставка.Параметры.Очистить();
    ТЗ = ЗапросВставка.Выполнить().Выгрузить();

    Для каждого СтрТЗ Из ТЗ Цикл
        Для А = 0 по ТЗ.Колонки.Количество()-1 Цикл
            Сообщить("" + А + ":" + СтрТЗ[А]);
        КонецЦикла;
    КонецЦикла;

КонецПроцедуры

Процедура Тест_Должен_ПрочитатьДанные_mssqlserver() Экспорт

	Соединение = Новый Соединение();
	Соединение.ТипСУБД = Соединение.ТипыСУБД.MSSQLServer;
    Соединение.СтрокаСоединения = ПолучитьТекстИзФайла("fixtures\ms-sql-server-con-str.txt");
	Соединение.Открыть();

	ЗапросВставка = Новый Запрос();
	ЗапросВставка.УстановитьСоединение(Соединение);

	ЗапросВставка.Текст = "IF OBJECT_ID(N'testtypes', N'U') IS NOT NULL DROP TABLE testtypes;";
	ЗапросВставка.ВыполнитьКоманду();


	ЗапросВставка.Текст = "Create table testtypes (col1 integer, col2 varchar(50), col3 char(10), col4 datetime, col5 bit, col6 float, col7 ntext)";
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "insert into testtypes (col1, col2, col3 , col4 , col5, col6, col7 ) values (@col1, @col2, @col3, @col4, @col5, @col6, @col7)";
	ЗапросВставка.УстановитьПараметр("col1", 1);
	ЗапросВставка.УстановитьПараметр("col2", "Сергей");
	ЗапросВставка.УстановитьПараметр("col3", "mycharstr");
	ЗапросВставка.УстановитьПараметр("col4", Дата(1980,9,13));
	ЗапросВставка.УстановитьПараметр("col5", Истина);
	ЗапросВставка.УстановитьПараметр("col6", 1.1234567890);
	ЗапросВставка.УстановитьПараметр("col7", "много много текста");
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "select * from testtypes";
    ЗапросВставка.Параметры.Очистить();
    ТЗ = ЗапросВставка.Выполнить().Выгрузить();

    Для каждого СтрТЗ Из ТЗ Цикл
        Для А = 0 по ТЗ.Колонки.Количество()-1 Цикл
            Сообщить("" + А + ":" + СтрТЗ[А]);
        КонецЦикла;
    КонецЦикла;

КонецПроцедуры

Процедура Тест_Должен_ПрочитатьДанные_mysql() Экспорт

	Соединение = Новый Соединение();
	Соединение.ТипСУБД = Соединение.ТипыСУБД.MySQL;
    Соединение.СтрокаСоединения = ПолучитьТекстИзФайла("fixtures\mysql-con-str.txt");
	Соединение.Открыть();

	ЗапросВставка = Новый Запрос();
	ЗапросВставка.УстановитьСоединение(Соединение);

	ЗапросВставка.Текст = "DROP TABLE IF EXISTS testtypes;";
	ЗапросВставка.ВыполнитьКоманду();


	ЗапросВставка.Текст = "Create table testtypes (col1 integer, col2 varchar(50), col3 char(10), col4 datetime, col5 bit, col6 float, col7 text)";
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "insert into testtypes (col1, col2, col3 , col4 , col5, col6, col7 ) values (@col1, @col2, @col3, @col4, @col5, @col6, @col7)";
	ЗапросВставка.УстановитьПараметр("col1", 1);
	ЗапросВставка.УстановитьПараметр("col2", "Сергей");
	ЗапросВставка.УстановитьПараметр("col3", "mycharstr");
	ЗапросВставка.УстановитьПараметр("col4", Дата(1980,9,13));
	ЗапросВставка.УстановитьПараметр("col5", Истина);
	ЗапросВставка.УстановитьПараметр("col6", 1.1234567890);
	ЗапросВставка.УстановитьПараметр("col7", "много много текста");
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "select * from testtypes";
    ЗапросВставка.Параметры.Очистить();
    ТЗ = ЗапросВставка.Выполнить().Выгрузить();

    Для каждого СтрТЗ Из ТЗ Цикл
        Для А = 0 по ТЗ.Колонки.Количество()-1 Цикл
            Сообщить("" + А + ":" + СтрТЗ[А]);
        КонецЦикла;
    КонецЦикла;
    
КонецПроцедуры

Процедура Тест_Должен_ПрочитатьДанные_postgresql() Экспорт

	Соединение = Новый Соединение();
	Соединение.ТипСУБД = Соединение.ТипыСУБД.PostgreSQL;
    Соединение.СтрокаСоединения = ПолучитьТекстИзФайла("fixtures\pgsql-con-str.txt");
	Соединение.Открыть();

	ЗапросВставка = Новый Запрос();
	ЗапросВставка.УстановитьСоединение(Соединение);

	ЗапросВставка.Текст = "DROP TABLE IF EXISTS testtypes;";
	ЗапросВставка.ВыполнитьКоманду();


	ЗапросВставка.Текст = "Create table testtypes (col1 integer, col2 varchar(50), col3 char(10), col4 date, col5 boolean, col6 float, col7 text)";
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "insert into testtypes (col1, col2, col3 , col4 , col5, col6, col7 ) values (@col1, @col2, @col3, @col4, @col5, @col6, @col7)";
	ЗапросВставка.УстановитьПараметр("col1", 1);
	ЗапросВставка.УстановитьПараметр("col2", "Сергей");
	ЗапросВставка.УстановитьПараметр("col3", "mycharstr");
	ЗапросВставка.УстановитьПараметр("col4", Дата(1980,9,13));
	ЗапросВставка.УстановитьПараметр("col5", Истина);
	ЗапросВставка.УстановитьПараметр("col6", 1.1234567890);
	ЗапросВставка.УстановитьПараметр("col7", "много много текста");
	ЗапросВставка.ВыполнитьКоманду();

	ЗапросВставка.Текст = "select * from testtypes";
    ЗапросВставка.Параметры.Очистить();
    ТЗ = ЗапросВставка.Выполнить().Выгрузить();

    Для каждого СтрТЗ Из ТЗ Цикл
        Для А = 0 по ТЗ.Колонки.Количество()-1 Цикл
            Сообщить("" + А + ":" + СтрТЗ[А]);
        КонецЦикла;
    КонецЦикла;
    
КонецПроцедуры


//////////////////////////////////////////////////////////////////////////////////////
// Инициализация

Инициализация();
